/*************************************************************
 * This file was automatically generated on 28.12.2011.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

#ifndef BRICK_IMU_H
#define BRICK_IMU_H

#include "ip_connection.h"

typedef Device IMU;

#define IMU_CALLBACK_ACCELERATION 40
#define IMU_CALLBACK_MAGNETIC_FIELD 41
#define IMU_CALLBACK_ANGULAR_VELOCITY 42
#define IMU_CALLBACK_ALL_DATA 43
#define IMU_CALLBACK_ORIENTATION 44
#define IMU_CALLBACK_QUATERNION 45
#define IMU_CALLBACK_ACCELERATION_REACHED 46
#define IMU_CALLBACK_MAGNETIC_FIELD_REACHED 47
#define IMU_CALLBACK_ANGULAR_VELOCITY_REACHED 48
#define IMU_CALLBACK_ALL_DATA_REACHED 49
#define IMU_CALLBACK_ORIENTATION_REACHED 50

void imu_create(IMU *imu, const char *uid);

int imu_get_acceleration(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_get_magnetic_field(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_get_angular_velocity(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_get_all_data(IMU *imu, int16_t *ret_acc_x, int16_t *ret_acc_y, int16_t *ret_acc_z, int16_t *ret_mag_x, int16_t *ret_mag_y, int16_t *ret_mag_z, int16_t *ret_ang_x, int16_t *ret_ang_y, int16_t *ret_ang_z, int16_t *ret_temperature);
int imu_get_orientation(IMU *imu, int16_t *ret_roll, int16_t *ret_pitch, int16_t *ret_yaw);
int imu_get_quaternion(IMU *imu, float *ret_w, float *ret_x, float *ret_y, float *ret_z);
int imu_get_imu_temperature(IMU *imu, int16_t *ret_temperature);
int imu_leds_on(IMU *imu);
int imu_leds_off(IMU *imu);
int imu_are_leds_on(IMU *imu, bool *ret_leds);
int imu_set_acceleration_range(IMU *imu, uint8_t range);
int imu_get_acceleration_range(IMU *imu, uint8_t *ret_range);
int imu_set_magnetometer_range(IMU *imu, uint8_t range);
int imu_get_magnetometer_range(IMU *imu, uint8_t *ret_range);
int imu_set_zero(IMU *imu);
int imu_set_debounce_period(IMU *imu, uint32_t debounce_period);
int imu_get_debounce_period(IMU *imu, uint32_t *ret_debounce_period);
int imu_set_acceleration_threshold(IMU *imu, uint8_t num, int16_t threshold[3], char option[3]);
int imu_get_acceleration_threshold(IMU *imu, uint8_t num, int16_t ret_threshold[3], char ret_option[3]);
int imu_set_magnetic_field_threshold(IMU *imu, uint8_t num, int16_t threshold[3], char option[3]);
int imu_get_magnetic_field_threshold(IMU *imu, uint8_t num, int16_t ret_threshold[3], char ret_option[3]);
int imu_set_angular_velocity_threshold(IMU *imu, uint8_t num, int16_t threshold[3], char option[3]);
int imu_get_angular_velocity_threshold(IMU *imu, uint8_t num, int16_t ret_threshold[3], char ret_option[3]);
int imu_set_all_data_threshold(IMU *imu, uint8_t num, int16_t threshold[9], char option[9]);
int imu_get_all_data_threshold(IMU *imu, uint8_t num, int16_t ret_threshold[9], char ret_option[9]);
int imu_set_orientation_threshold(IMU *imu, uint8_t num, int16_t threshold[3], char option[3]);
int imu_get_orientation_threshold(IMU *imu, uint8_t num, int16_t ret_threshold[3], char ret_option[3]);
int imu_set_acceleration_period(IMU *imu, uint32_t period);
int imu_get_acceleration_period(IMU *imu, uint32_t *ret_period);
int imu_set_magnetic_field_period(IMU *imu, uint32_t period);
int imu_get_magnetic_field_period(IMU *imu, uint32_t *ret_period);
int imu_set_angular_velocity_period(IMU *imu, uint32_t period);
int imu_get_angular_velocity_period(IMU *imu, uint32_t *ret_period);
int imu_set_all_data_period(IMU *imu, uint32_t period);
int imu_get_all_data_period(IMU *imu, uint32_t *ret_period);
int imu_set_orientation_period(IMU *imu, uint32_t period);
int imu_get_orientation_period(IMU *imu, uint32_t *ret_period);
int imu_set_quaternion_period(IMU *imu, uint32_t period);
int imu_get_quaternion_period(IMU *imu, uint32_t *ret_period);
int imu_acceleration(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_magnetic_field(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_angular_velocity(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_all_data(IMU *imu, int16_t *ret_acc_x, int16_t *ret_acc_y, int16_t *ret_acc_z, int16_t *ret_mag_x, int16_t *ret_mag_y, int16_t *ret_mag_z, int16_t *ret_ang_x, int16_t *ret_ang_y, int16_t *ret_ang_z, int16_t *ret_temperature);
int imu_orientation(IMU *imu, int16_t *ret_roll, int16_t *ret_pitch, int16_t *ret_yaw);
int imu_quaternion(IMU *imu, float *ret_w, float *ret_x, float *ret_y, float *ret_z);
int imu_acceleration_reached(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_magnetic_field_reached(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_angular_velocity_reached(IMU *imu, int16_t *ret_x, int16_t *ret_y, int16_t *ret_z);
int imu_all_data_reached(IMU *imu, int16_t *ret_acc_x, int16_t *ret_acc_y, int16_t *ret_acc_z, int16_t *ret_mag_x, int16_t *ret_mag_y, int16_t *ret_mag_z, int16_t *ret_ang_x, int16_t *ret_ang_y, int16_t *ret_ang_z, int16_t *ret_temperature);
int imu_orientation_reached(IMU *imu, int16_t *ret_roll, int16_t *ret_pitch, int16_t *ret_yaw);
int imu_get_version(IMU *imu, char ret_name[40], uint8_t ret_firmware_version[3], uint8_t ret_binding_version[3]);
void imu_register_callback(IMU *imu, uint8_t cb, void *func);

#endif